/*
	This file is part of CrocoLib.

	CrocoLib is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CrocoLib is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Ceremony.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "crASIC.h"

// ----------------------------------------------------------------------------
void __LIB__ crASICUnlock( )
{
#asm
	di;

	ld b, $bc;
	ld hl, dataSequence;
	ld e, 17;

.loopSequence
	ld a, (hl);
	out (c), a;
	inc hl;
	dec e;
	jr nz, loopSequence;

	ei;

	jr endUnlock;

.dataSequence
	defb $ff, $00, $ff, $77
	defb $b3, $51, $a8, $d4
	defb $62, $39, $9c, $46
	defb $2b, $15, $8a, $cd
	defb $ee

.endUnlock
#endasm
}

